import { deepAssign } from '@codeperate/utils';
import { StringWidgetConfig } from './widgets/StringWidget.config';
import { TextAreaWidgetConfig } from './widgets/TextAreaWidget.config';
import { PasswordWidgetConfig } from './widgets/PasswordWidget.config';
import { ArrayWidgetConfig } from './widgets/ArrayWidget.config';
import { NumberWidgetConfig } from './widgets/NumberWidget.config';
import { DateWidgetConfig } from './widgets/DateWidget.config';
import { SectionWidgetConfig } from './widgets/SectionWidget.config';
import { ObjectWidgetConfig } from './widgets/ObjectWidget.config';
export interface ComponentsConfig {
    [key: string]: any;
    ObjectWidget: ObjectWidgetConfig;
    StringWidget: StringWidgetConfig;
    TextAreaWidget: TextAreaWidgetConfig;
    PasswordWidget: PasswordWidgetConfig;
    ArrayWidget: ArrayWidgetConfig;
    NumberWidget: NumberWidgetConfig;
    DateWidget: DateWidgetConfig;
    SectionWidget: SectionWidgetConfig;
}

const config: ComponentsConfig = {} as ComponentsConfig;

export function useConfig<T extends keyof ComponentsConfig, K>(key: T, defaultVal?: K) {
    return deepAssign<K>(config?.[key] ?? {}, defaultVal ?? {});
}

export function setConfig<T extends keyof ComponentsConfig>(key: T, value: ComponentsConfig[T]) {
    config[key] = value;
}
